//// РИСОВАЛКА ПИКСЕЛЬНАЯ
#include <VGAX.h>
VGAX vga;
byte x=60;//переменные координат курсора
byte y=30;//
byte xx=x;//переменные координат предыдущего положения курсора
byte yy=y;//
byte cvet=3;//
byte k=0;//
int t=30;//
void setup() {
 
  vga.begin();
  vga.clear(0); 
 digitalWrite(A1, HIGH);// включить подтягивающий резистор (курсор вправо) комбинация клавиш вправо-влево это смена режимов курсор (не рисовать)- рисовать 
 digitalWrite(A2, HIGH);// включить подтягивающий резистор (курсор вверх)  комбинация клавиш вверх-вниз это смена цвета рисования
 digitalWrite(A3, HIGH);// включить подтягивающий резистор (курсор влево)
 digitalWrite(A4, HIGH);// включить подтягивающий резистор (курсор вниз)
 
}
void loop() {
 vga.fillrect(0,0,2,4,cvet);//маркер режима цвета
 vga.fillrect(3,0,2,4,1);//маркер режима рисования пикселями  
/////  
  kursor_1();
}
/////////////////////////////////////////////////////////
/////// базовая функция рисования точками по следу курсора 
void kursor_1()//
{
xx=x;yy=y;
if(!digitalRead(A1)&&!digitalRead(A3)){k=!k;vga.delay(10*t);}// смена режимов курсор (не рисовать)-рисовать 
if(!digitalRead(A2)&&!digitalRead(A4)){cvet++;if(cvet>3){cvet=1;}if(cvet<1){cvet=3;}vga.delay(10*t);}// смена цвета рисования
//////   
if(!digitalRead(A1)&&x!=119){x++;}
if(!digitalRead(A3)&&x!=0){x--;}
vga.delay(t); 
if(!digitalRead(A2)&&y!=0){y--;}
if(!digitalRead(A4)&&y!=59){y++;}
vga.delay(t); 
if(xx!=x||yy!=y){vga.putpixel(xx,yy,k*cvet);}
vga.putpixel(x,y,3);
vga.delay(t);
}
///////////////////////////////////////////////////////////

